/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import React from "react";
import clsx from "clsx";
//@ts-ignore
import styles from "./HomepageFeatures.module.css";
const FeatureList = [
    {
        title: "Easy to Use",
        image: "/img/EasytoUse.png",
        description: (React.createElement(React.Fragment, null, "Strata provides SDKs to launch Tokens in an instant. No Rust or Solana experience needed!")),
    },
    {
        title: "Free and Open",
        image: "/img/FreeandOpen.png",
        description: (React.createElement(React.Fragment, null, "Strata is free to use and Open Source. Launch your token without someone else taking a cut!")),
    },
    {
        title: "Build Quickly with React",
        image: "/img/BuildwithReact.png",
        description: (React.createElement(React.Fragment, null, "Strata comes with hooks and helpers to make coding using React a breeze.")),
    },
];
function Feature({ title, image, description }) {
    return (React.createElement("div", { className: clsx("col col--4") },
        React.createElement("div", { className: "text--center" },
            React.createElement("img", { style: { width: "100px", height: "100px" }, className: styles.featureSvg, alt: title, src: image })),
        React.createElement("div", { className: "text--center padding-horiz--md" },
            React.createElement("h3", null, title),
            React.createElement("p", null, description))));
}
export default function HomepageFeatures() {
    return (React.createElement("section", { className: styles.features },
        React.createElement("div", { className: "container" },
            React.createElement("div", { className: "row" }, FeatureList.map((props, idx) => (React.createElement(Feature, { key: idx, ...props })))))));
}
//# sourceMappingURL=HomepageFeatures.js.map