import React from "react";
import { DisburseFunds } from "@strata-foundation/marketplace-ui";
import { useVariables } from "../../theme/Root/variables";
import { WalletMultiButton } from "@solana/wallet-adapter-react-ui";
import { useWallet } from "@solana/wallet-adapter-react";
import ReactShadow from "react-shadow/emotion";
import { Box, CSSReset } from "@chakra-ui/react";
export function VariableDisburseFunds({ closeBonding = false, closeEntangler = false, }) {
    const variables = useVariables();
    const { connected } = useWallet();
    if (!connected) {
        return React.createElement(WalletMultiButton, null);
    }
    return (
    // @ts-ignore
    React.createElement(ReactShadow.div, null,
        React.createElement(Box, { mb: "16px" },
            React.createElement(CSSReset, null),
            React.createElement(DisburseFunds, { id: variables.id, tokenBondingKey: variables.tokenBondingKey, closeBonding: closeBonding, closeEntangler: closeEntangler }))));
}
//# sourceMappingURL=index.js.map